"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class VariantTraitAssociation(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {}

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_2 import opencb as opencb_1_3_0

        return {
            "clinvar": opencb_1_3_0.ClinVar,
            "cosmic": opencb_1_3_0.Cosmic,
            "gwas": opencb_1_3_0.Gwas,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_2 import opencb as opencb_1_3_0

        return {
            "org.opencb.biodata.models.variant.avro.ClinVar": opencb_1_3_0.ClinVar,
            "org.opencb.biodata.models.variant.avro.Cosmic": opencb_1_3_0.Cosmic,
            "org.opencb.biodata.models.variant.avro.Gwas": opencb_1_3_0.Gwas,
            "org.opencb.biodata.models.variant.avro.VariantTraitAssociation": opencb_1_3_0.VariantTraitAssociation,
        }

    __slots__ = [
        "clinvar",
        "cosmic",
        "gwas",
    ]

    def __init__(
        self,
        clinvar=None,
        cosmic=None,
        gwas=None,
        validate=None,
        **kwargs
    ):
        """Initialise the opencb_1_3_0.VariantTraitAssociation model.

        :param clinvar:
        :type clinvar: None | list[ClinVar]
        :param cosmic:
        :type cosmic: None | list[Cosmic]
        :param gwas:
        :type gwas: None | list[Gwas]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.3.0"
